int _pEcho;
int _pTrigger;

void setup(){
  Serial.begin(9600);
  pinMode(8, INPUT);  // conexion del pinEcho
  pinMode(9, OUTPUT); // conexion del pinTrigger
  pinMode(6, OUTPUT);
  inicia_SR(8, 9);
  
}


void inicia_SR(int pinEcho, int pinTrigger) {
  extern int _pEcho;
  extern int _pTrigger;

  _pEcho = pinEcho;
  _pTrigger = pinTrigger;
}

float distanciaCM() {
  extern int _pEcho;
  extern int _pTrigger;

  long duracion;  // vamos a guardar microsegundos
  
  digitalWrite(_pTrigger, LOW);

  delayMicroseconds(5); // he visto valores desde 2 hasta 5.
  digitalWrite(_pTrigger, HIGH);

  // la unidad espera un pulso que sirve de disparo para que
  // comience el calculo de la distancia.
  delayMicroseconds(10); // ancho minimo que pide la unidad HC-SR04
  digitalWrite(_pTrigger, LOW);
  // nos devuelve un pulso cuya anchura es el tiempo (us) que demora
  // en volver el echo de un tren de pulsos a 40 kHz.
  // en resumen, nos da la distancia en formato tiempo, que tenemos
  // que alimentar a una formula para calcular la distancia.
  duracion = pulseIn(_pEcho,HIGH);
  
  return (duracion /29.0) / 2 ;
}

void loop(){
  float distancia = distanciaCM();
  tone(6, int(10000/distancia));
  Serial.print("Distancia ");
  Serial.print(distancia);
  Serial.println(" cm");
  delay(100);
}

