#include <SPI.h>

#include "MPU6000.h"

// conector SPI utilizado:
int imuPin = 7; // chip select del IMU

// connect BT module TX to D0
// connect BT module RX to D1
// connect BT Vcc to 3,3V, GND to GND

int botonPin = 2;
int buttonState;
int lastButtonState;
long lastDebounceTime = 0;
long debounceDelay = 50;

int ledState;
int ledPin = 6;

int _pEcho;
int _pTrigger;


void setup()  
{
  Serial.begin(9600);
  // Send test message to other device
  Serial.println("Hello from Arduino");
  pinMode(ledPin, OUTPUT);
  pinMode(botonPin, INPUT); // pushbutton
  
  lastButtonState = LOW;
  ledState = LOW;
  
  pinMode(8, INPUT);  // conexion del pinEcho
  pinMode(9, OUTPUT); // conexion del pinTrigger
  inicia_SR(8,9);
}
char a; // stores incoming character from other device
void loop() 
{
  long distancia;
  
  if (Serial.available())
  // if text arrived in from BT serial...
  {
    a=(Serial.read());
    if (a=='1')
    {
      digitalWrite(ledPin, HIGH);
      Serial.println("LED on");
      
      ledState = HIGH;
    }
    if (a=='2')
    {
      digitalWrite(ledPin, LOW);
      Serial.println("LED off");
      
      ledState = LOW;
    }
    if (a=='?')
    {
      Serial.println("Send '1' to turn LED on");
      Serial.println("Send '2' to turn LED on");
    }   
    // you can add more "if" statements with other characters to add more commands
  }
  
  // read the state of the switch into a local variable:
  int reading = digitalRead(botonPin);
  int lectura;
  // check to see if you just pressed the button 
  // (i.e. the input went from LOW to HIGH),  and you've waited 
  // long enough since the last press to ignore any noise:  

  // If the switch changed, due to noise or pressing:
  if (reading != lastButtonState) {
    // reset the debouncing timer
    lectura = reading;
 
    while (((millis() - lastDebounceTime) > debounceDelay) && lectura == reading) {
        lastDebounceTime = millis();        
        reading = digitalRead(botonPin);
    }
    if (lectura == reading) {
        do reading = digitalRead(botonPin);
        while (lectura == reading);
        ledState = !ledState;
        digitalWrite(ledPin, ledState);
        lastButtonState = reading;
    }
  }
  
  if (ledState == HIGH) {
     distancia = distanciaPulso();
     Serial.print("Distancia ");
     Serial.print(distancia);
     Serial.println(" cm");
  }
  //delay(100);
}
