#include <SPI.h>

#include "MPU6000.h"

// conector SPI utilizado:
// MPU000 sensor attached to pins:
//   D13 : SCLK
//   D12 : SDO
//   D11 : SDI     // este y los anteriores son estandar para SPI.h
//   D07 : /CS
byte imuPin = 7; // chip select del IMU
//   VCC a 5V y GND como le corresponda.

// connect BT module TX to D0
// connect BT module RX to D1
// connect BT Vcc to 3,3V, GND to GND

byte botonPin = 2;
int buttonState;
int lastButtonState;
long lastDebounceTime = 0;
long debounceDelay = 50;

int ledState;
byte ledPin = 6;


void setup()  
{
  // Serial.begin(9600);
  
  SPI.begin();
  
  delay(100);

  pinMode(imuPin, OUTPUT);

  MiniinitMPU(imuPin);
  
  // para los settings de SPI ver MPU6000.h: SPISettings.
  delay(1000);
  
  Serial.begin(9600);
  // Send test message to other device
  Serial.println("Hola, me llamo Arduino, y soy tu nuevo vecino");
  pinMode(ledPin, OUTPUT);
  pinMode(botonPin, INPUT); // pushbutton
  
  lastButtonState = LOW;
  ledState = LOW;
  
  pinMode(8, INPUT);  // conexion del pinEcho
  pinMode(9, OUTPUT); // conexion del pinTrigger
  inicia_SR(8,9);
}

char a; // guarda el caracter proveniente del Serial.

volatile unsigned long tiempo;

void loop() 
{
  long distancia;
  
  short int xacc=0x0, yacc=0x0, zacc=0x0;
  float fxacc, fyacc, fzacc;
  byte xaccl, xacch;
  byte yaccl, yacch;
  byte zaccl, zacch;
  
  short int temp;
  byte templ, temph;

  short int xgir=0x0, ygir=0x0, zgir=0x0;
  float fxgir, fygir, fzgir;
  byte xgirl, xgirh;
  byte ygirl, ygirh;
  byte zgirl, zgirh;
  
  
  if (Serial.available())
  // if text arrived in from BT serial...
  {
    a=(Serial.read());
    if (a=='1')
    {
      digitalWrite(ledPin, HIGH);
      Serial.println("LED on");
      
      ledState = HIGH;
    }
    if (a=='2')
    {
      digitalWrite(ledPin, LOW);
      Serial.println("LED off");
      
      ledState = LOW;
    }
    if (a=='?')
    {
      Serial.println("Send '1' to turn LED on");
      Serial.println("Send '2' to turn LED on");
    }   
    // you can add more "if" statements with other characters to add more commands
  }
  
  // read the state of the switch into a local variable:
  int reading = digitalRead(botonPin);
  int lectura;
  // check to see if you just pressed the button 
  // (i.e. the input went from LOW to HIGH),  and you've waited 
  // long enough since the last press to ignore any noise:  

  // If the switch changed, due to noise or pressing:
  if (reading != lastButtonState) {
    // reset the debouncing timer
    lectura = reading;
 
    while (((millis() - lastDebounceTime) > debounceDelay) && lectura == reading) {
        lastDebounceTime = millis();        
        reading = digitalRead(botonPin);
    }
    if (lectura == reading) {
        do reading = digitalRead(botonPin);
        while (lectura == reading);
        ledState = !ledState;
        digitalWrite(ledPin, ledState);
        lastButtonState = reading;
    }
  }
  
  if (ledState == HIGH) {
     tiempo = micros();
     Serial.print("Tiempo: ");
     Serial.println(tiempo);
     
     
     distancia = distanciaPulso();
     Serial.print("Distancia ");
     Serial.println(distancia);
     
     
     SPI.beginTransaction(settingsHIGH); // definido en MPU6000.h
     digitalWrite(imuPin, LOW);
       SPI.transfer(ACCEL_XOUTH | 0x80); // see "readRegister()"
       xacch = SPI.transfer(0x00);
       xaccl = SPI.transfer(0x00);
       yacch = SPI.transfer(0x00);
       yaccl = SPI.transfer(0x00);
       zacch = SPI.transfer(0x00);
       zaccl = SPI.transfer(0x00);

       temph = SPI.transfer(0x00);
       templ = SPI.transfer(0x00); 

       xgirh = SPI.transfer(0x00);
       xgirl = SPI.transfer(0x00);
       ygirh = SPI.transfer(0x00);
       ygirl = SPI.transfer(0x00);
       zgirh = SPI.transfer(0x00);
       zgirl = SPI.transfer(0x00);
     digitalWrite(imuPin, HIGH); // cortar SPI
     SPI.endTransaction();
    
    // ACCELEROMETER
    // la aceleracion viene en multiplos de "g" (9.8 m/(s*s))
    //
    Serial.print("Acc = ("); // Serial.print(xacch);Serial.print(", ");Serial.print(xaccl);
       xacc = xacch; xacc = xacc << 8;   xacc = xacc | xaccl;
       fxacc = xacc / 8192.0;
       // Serial.print(") = ");
    Serial.print(fxacc); Serial.print(", ");

       //  Serial.print("  , yacc = ("); // Serial.print(yacch);Serial.print(", ");Serial.print(yaccl);
       yacc = yacch; yacc = yacc << 8;   yacc = yacc | yaccl;
       fyacc = yacc / 8192.0;
       // Serial.print(") = ");
    Serial.print(fyacc); Serial.print(", ");

        // Serial.print("  , zacc = (");Serial.print(zacch);Serial.print(", ");Serial.print(zaccl);
        zacc = zacch; zacc = zacc << 8;   zacc = zacc | zaccl;
        fzacc = zacc / 8192.0;
        // Serial.print(") = ");
    Serial.print(fzacc); Serial.println(")");

    // GYROSCPE
    // la velocidad angular viene dada en grados/s
    //
    Serial.print("Gyr = ("); // Serial.print(xgirh);Serial.print(", ");Serial.print(xgirl);
       xgir = xgirh; xgir = xgir << 8;   xgir = xgir | xgirl;
       fxgir = xgir / 131.0;
       // Serial.print(") = ");
    Serial.print(fxgir); Serial.print(", ");

       // Serial.print("  , ygir = ("); // Serial.print(ygirh);Serial.print(", ");Serial.print(ygirl);
       ygir = ygirh; ygir = ygir << 8;   ygir = ygir | ygirl;
       fygir = ygir / 131.0;
       // Serial.print(") = ");
    Serial.print(fygir); Serial.print(", ");

        // Serial.print("  , zgir = (");Serial.print(zgirh);Serial.print(", ");Serial.print(zgirl);
        zgir = zgirh; zgir = zgir << 8;   zgir = zgir | zgirl;
        fzgir = zgir / 131.0;
        // Serial.print(") = ");
    Serial.print(fzgir); Serial.println(")\n");
    
  }
  //delay(100);
}
